SoShape Class Referenceabstract
Node Classes

The SoShape class is the superclass for geometry shapes. More...

`#include <Inventor/nodes/SoShape.h>`

Inheritance diagram for SoShape:

## Public Types

enum | TriangleShape { TRIANGLE_STRIP , TRIANGLE_FAN , TRIANGLES , POLYGON , QUADS , QUAD_STRIP , POINTS , LINES , LINE_STRIP }
Public Types inherited from SoNode

enum

NodeType {
INVENTOR = 0x0000 , VRML1 = 0x0001 , VRML2 = 0x0002 , INVENTOR_1 = 0x0004 ,
INVENTOR_2_0 = 0x0008 , INVENTOR_2_1 = 0x0010 , INVENTOR_2_5 = 0x0020 , INVENTOR_2_6 = 0x0040 ,
COIN_1_0 = 0x0080 , COIN_2_0 = 0x0100 , EXTENSION = 0x0200 , COIN_2_2 = 0x0400 ,
COIN_2_3 = 0x0800 , COIN_2_4 = 0x1000 , INVENTOR_5_0 = 0x2000 , COIN_2_5 = 0x4000 ,
COIN_3_0 = 0x8000 , INVENTOR_6_0 = 0x10000 , COIN_4_0 = 0x20000
}

## Public Member Functions

virtual SoType | getTypeId (void) const
virtual SbBool | affectsState (void) const
virtual void | notify (SoNotList *nl)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | computeBBox (SoAction *action, SbBox3f &box, SbVec3f &center)=0
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
const SoBoundingBoxCache * | getBoundingBoxCache (void) const
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual void | doAction (SoAction *action)
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | pick (SoPickAction *action)
virtual void | search (SoSearchAction *action)
virtual void | write (SoWriteAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
virtual void | startNotify (void)
SbUniqueId | getNodeId (void) const
virtual SoChildList * | getChildren (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoNode * | addToCopyDict (void) const
virtual void | copyContents (const SoFieldContainer *from, SbBool copyconnections)
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
| Returns `TRUE` if the type of this object is either of the same type or inherited from type.
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions

static SoType | getClassTypeId (void)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | getScreenSize (SoState *const state, const SbBox3f &boundingbox, SbVec2s &rectsize)
static float | getDecimatedComplexity (SoState *state, float complexity)
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | initClasses (void)
static SbUniqueId | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Protected Member Functions

virtual const SoFieldData * | getFieldData (void) const
| SoShape (void)
virtual | ~SoShape ()
float | getComplexityValue (SoAction *action)
virtual void | generatePrimitives (SoAction *action)=0
virtual SbBool | shouldGLRender (SoGLRenderAction *action)
void | beginSolidShape (SoGLRenderAction *action)
void | endSolidShape (SoGLRenderAction *action)
void | GLRenderBoundingBox (SoGLRenderAction *action)
SbBool | shouldPrimitiveCount (SoGetPrimitiveCountAction *action)
SbBool | shouldRayPick (SoRayPickAction *const action)
void | computeObjectSpaceRay (SoRayPickAction *const action)
void | computeObjectSpaceRay (SoRayPickAction *const action, const SbMatrix &matrix)
virtual SoDetail * | createTriangleDetail (SoRayPickAction *action, const SoPrimitiveVertex *v1, const SoPrimitiveVertex *v2, const SoPrimitiveVertex *v3, SoPickedPoint *pp)
virtual SoDetail * | createLineSegmentDetail (SoRayPickAction *action, const SoPrimitiveVertex *v1, const SoPrimitiveVertex *v2, SoPickedPoint *pp)
virtual SoDetail * | createPointDetail (SoRayPickAction *action, const SoPrimitiveVertex *v, SoPickedPoint *pp)
void | invokeTriangleCallbacks (SoAction *const action, const SoPrimitiveVertex *const v1, const SoPrimitiveVertex *const v2, const SoPrimitiveVertex *const v3)
void | invokeLineSegmentCallbacks (SoAction *const action, const SoPrimitiveVertex *const v1, const SoPrimitiveVertex *const v2)
void | invokePointCallbacks (SoAction *const action, const SoPrimitiveVertex *const v)
void | beginShape (SoAction *const action, const TriangleShape shapetype, SoDetail *const detail=NULL)
void | shapeVertex (const SoPrimitiveVertex *const v)
void | endShape (void)
void | generateVertex (SoPrimitiveVertex *const pv, const SbVec3f &point, const SbBool useTexFunc, const SoMultiTextureCoordinateElement *const tce, const float s, const float t, const SbVec3f &normal)
void | generateVertex (SoPrimitiveVertex *const pv, const SbVec3f &point, const SbBool useTexFunc, const SoMultiTextureCoordinateElement *const tce, const float s, const float t, const float r, const SbVec3f &normal)
SbBool | startVertexArray (SoGLRenderAction *action, const SoCoordinateElement *coords, const SbVec3f *pervertexnormals, const SbBool texpervertex, const SbBool colorpervertex)
void | finishVertexArray (SoGLRenderAction *action, const SbBool vbo, const SbBool normpervertex, const SbBool texpervertex, const SbBool colorpervertex)
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const
virtual SoNotRec | createNotRec (void)

## Static Protected Member Functions

static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Additional Inherited Members

Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01 , IS_GROUP = 0x02 }
Protected Attributes inherited from SoNode
SbUniqueId | uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn
Static Protected Attributes inherited from SoNode
static SbUniqueId | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoShape class is the superclass for geometry shapes.

The node types which have actual geometry to render inherit this class. For convenience, the SoShape class contains various common code used by the subclasses.

## Member Enumeration Documentation

## TriangleShape

enum SoShape::TriangleShape

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## Constructor & Destructor Documentation

## SoShape()

SoShape::SoShape | ( | void |  | ) |

protected

Constructor.

## ~SoShape()

SoShape::~SoShape | ( |  | ) |

protected virtual

Destructor.

## Member Function Documentation

## getClassTypeId()

SoType SoShape::getClassTypeId | ( | void |  | ) |

static

This static method returns the SoType object associated with objects of this class.

## getTypeId()

SoType SoShape::getTypeId | ( | void |  | ) | const

virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.

Implements SoBase.

Reimplemented in SoAsciiText, SoCone, SoCube, SoCylinder, SoFaceSet, SoImage, SoIndexedFaceSet, SoIndexedLineSet, SoIndexedMarkerSet, SoIndexedNurbsCurve, SoIndexedNurbsSurface, SoIndexedPointSet, SoIndexedShape, SoIndexedTriangleStripSet, SoLineSet, SoMarkerSet, SoNonIndexedShape, SoNurbsCurve, SoNurbsSurface, SoPointSet, SoQuadMesh, SoSphere, SoText2, SoText3, SoTriangleStripSet, SoVertexShape, SoVRMLBox, SoVRMLCone, SoVRMLCylinder, SoVRMLElevationGrid, SoVRMLExtrusion, SoVRMLGeometry, SoVRMLIndexedFaceSet, SoVRMLIndexedLine, SoVRMLIndexedLineSet, SoVRMLIndexedShape, SoVRMLPointSet, SoVRMLSphere, SoVRMLText, SoVRMLVertexLine, SoVRMLVertexPoint, and SoVRMLVertexShape.

## getFieldDataPtr()

const SoFieldData ** SoShape::getFieldDataPtr | ( | void |  | ) |

static protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Returns the SoFieldData class which holds information about fields in this node.

## getFieldData()

const SoFieldData * SoShape::getFieldData | ( | void |  | ) | const

protected virtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoFieldContainer.

Reimplemented in SoAsciiText, SoCone, SoCube, SoCylinder, SoFaceSet, SoImage, SoIndexedFaceSet, SoIndexedLineSet, SoIndexedMarkerSet, SoIndexedNurbsCurve, SoIndexedNurbsSurface, SoIndexedPointSet, SoIndexedShape, SoIndexedTriangleStripSet, SoLineSet, SoMarkerSet, SoNonIndexedShape, SoNurbsCurve, SoNurbsSurface, SoPointSet, SoQuadMesh, SoSphere, SoText2, SoText3, SoTriangleStripSet, SoVertexShape, SoVRMLBox, SoVRMLCone, SoVRMLCylinder, SoVRMLElevationGrid, SoVRMLExtrusion, SoVRMLGeometry, SoVRMLIndexedFaceSet, SoVRMLIndexedLine, SoVRMLIndexedLineSet, SoVRMLIndexedShape, SoVRMLPointSet, SoVRMLSphere, SoVRMLText, SoVRMLVertexLine, SoVRMLVertexPoint, and SoVRMLVertexShape.

## affectsState()

SbBool SoShape::affectsState | ( | void |  | ) | const

virtual

Returns `TRUE` if the node could have any effect on the state during traversal.

If it returns `FALSE`, no data in the traversal state will change from the pre-traversal state to the post-traversal state. The SoSeparator node will for instance return `FALSE`, as it pushes and pops the state before and after traversal of its children. All SoShape nodes will also return `FALSE`, as just pushing out geometry data to the rendering engine won't affect the actual rendering state.

The default method returns `TRUE`, on a "better safe than sorry" philosophy.

Reimplemented from SoNode.

## notify()

void SoShape::notify | ( | SoNotList * | l | ) |

virtual

Notifies all auditors for this instance when changes are made.

Reimplemented from SoNode.

Reimplemented in SoAsciiText, SoImage, SoIndexedLineSet, SoIndexedPointSet, SoText3, SoVertexShape, SoVRMLElevationGrid, SoVRMLExtrusion, SoVRMLGeometry, SoVRMLIndexedLine, SoVRMLIndexedLineSet, SoVRMLIndexedShape, SoVRMLText, SoVRMLVertexLine, SoVRMLVertexPoint, and SoVRMLVertexShape.

## getBoundingBox()

void SoShape::getBoundingBox | ( | SoGetBoundingBoxAction * | action | ) |

virtual

Action method for the SoGetBoundingBoxAction.

Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node.

Nodes influencing how geometry nodes calculate their bounding box also override this method to change the relevant state variables.

Reimplemented from SoNode.

Reimplemented in SoIndexedLineSet, SoIndexedNurbsCurve, SoIndexedPointSet, SoLineSet, SoNurbsCurve, SoPointSet, SoVRMLIndexedLineSet, SoVRMLPointSet, SoVRMLVertexLine, SoVRMLVertexPoint, and SoVRMLVertexShape.

## GLRender()

void SoShape::GLRender | ( | SoGLRenderAction * | action | ) |

virtual

Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoNode.

Reimplemented in SoAsciiText, SoCone, SoCube, SoCylinder, SoFaceSet, SoImage, SoIndexedFaceSet, SoIndexedLineSet, SoIndexedMarkerSet, SoIndexedNurbsCurve, SoIndexedNurbsSurface, SoIndexedPointSet, SoIndexedTriangleStripSet, SoLineSet, SoMarkerSet, SoNurbsCurve, SoNurbsSurface, SoPointSet, SoQuadMesh, SoSphere, SoText2, SoText3, SoTriangleStripSet, SoVRMLBox, SoVRMLCone, SoVRMLCylinder, SoVRMLElevationGrid, SoVRMLExtrusion, SoVRMLIndexedFaceSet, SoVRMLIndexedLineSet, SoVRMLPointSet, SoVRMLSphere, SoVRMLText, SoVRMLVertexLine, SoVRMLVertexPoint, and SoVRMLVertexShape.

## rayPick()

void SoShape::rayPick | ( | SoRayPickAction * | action | ) |

virtual

Calculates picked point based on primitives generated by subclasses.

Reimplemented from SoNode.

Reimplemented in SoCone, SoCube, SoCylinder, SoImage, SoIndexedNurbsCurve, SoIndexedNurbsSurface, SoNurbsCurve, SoNurbsSurface, SoSphere, SoText2, SoVRMLBox, SoVRMLCone, SoVRMLCylinder, SoVRMLElevationGrid, and SoVRMLSphere.

## callback()

void SoShape::callback | ( | SoCallbackAction * | action | ) |

virtual

Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoNode.

Reimplemented in SoVRMLVertexLine, SoVRMLVertexPoint, and SoVRMLVertexShape.

## computeBBox()

virtual void SoShape::computeBBox | ( | SoAction * | action,
|  | SbBox3f & | box,
|  | SbVec3f & | center )

pure virtual

Implemented by SoShape subclasses to let the SoShape superclass know the exact size and weighted center point of the shape's bounding box.

The bounding box and center point should be calculated and returned in the local coordinate system.

The method implements action behavior for shape nodes for SoGetBoundingBoxAction. It is invoked from SoShape::getBoundingBox(). (Subclasses should not override SoNode::getBoundingBox().)

The box parameter sent in is guaranteed to be an empty box, while center is undefined upon function entry.

Implemented in SoAsciiText, SoCone, SoCube, SoCylinder, SoFaceSet, SoImage, SoIndexedNurbsCurve, SoIndexedNurbsSurface, SoIndexedShape, SoLineSet, SoNurbsCurve, SoNurbsSurface, SoPointSet, SoQuadMesh, SoSphere, SoText2, SoText3, SoTriangleStripSet, SoVRMLBox, SoVRMLCone, SoVRMLCylinder, SoVRMLElevationGrid, SoVRMLExtrusion, SoVRMLIndexedLine, SoVRMLIndexedShape, SoVRMLSphere, SoVRMLText, and SoVRMLVertexPoint.

## getPrimitiveCount()

void SoShape::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action | ) |

virtual

Action method for the SoGetPrimitiveCountAction.

Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action.

Nodes influencing how geometry nodes calculate their primitive count also override this method to change the relevant state variables.

Reimplemented from SoNode.

Reimplemented in SoAsciiText, SoCone, SoCube, SoCylinder, SoFaceSet, SoImage, SoIndexedFaceSet, SoIndexedLineSet, SoIndexedNurbsCurve, SoIndexedNurbsSurface, SoIndexedPointSet, SoIndexedTriangleStripSet, SoLineSet, SoMarkerSet, SoNurbsCurve, SoNurbsSurface, SoPointSet, SoQuadMesh, SoSphere, SoText2, SoText3, SoTriangleStripSet, SoVRMLBox, SoVRMLCone, SoVRMLCylinder, SoVRMLElevationGrid, SoVRMLExtrusion, SoVRMLIndexedFaceSet, SoVRMLIndexedLineSet, SoVRMLSphere, SoVRMLText, and SoVRMLVertexPoint.

## getScreenSize()

void SoShape::getScreenSize | ( | SoState *const | state,
|  | const SbBox3f & | boundingbox,
|  | SbVec2s & | rectsize )

static

A convenience function that returns the size of a boundingbox projected onto the screen. Useful for `SCREEN_SPACE` complexity geometry.

## getDecimatedComplexity()

float SoShape::getDecimatedComplexity | ( | SoState * | state,
|  | float | complexity )

static

Not implemented in Coin. Should probably have been private in TGS Inventor API.

## getBoundingBoxCache()

const SoBoundingBoxCache * SoShape::getBoundingBoxCache | ( | void |  | ) | const

Return the bounding box cache for this shape. It might return NULL if no bounding box cache has been created. If not NULL, the caller must check if the cache is valid before using it. This can be done using SoCache::isValid().

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Since
  Coin 2.0

## getComplexityValue()

float SoShape::getComplexityValue | ( | SoAction * | action | ) |

protected

Returns the complexity value to be used by subclasses. Considers complexity type. For `OBJECT_SPACE` complexity this will be a number between 0 and 1. For `SCREEN_SPACE` complexity it is a number from 0 and up.

## generatePrimitives()

virtual void SoShape::generatePrimitives | ( | SoAction * | action | ) |

protected pure virtual

The method implements action behavior for shape nodes for SoCallbackAction. It is invoked from SoShape::callback(). (Subclasses should not override SoNode::callback().)

The subclass implementations uses the convenience methods SoShape::beginShape(), SoShape::shapeVertex(), and SoShape::endShape(), with SoDetail instances, to pass the primitives making up the shape back to the caller.

Implemented in SoAsciiText, SoCone, SoCube, SoCylinder, SoFaceSet, SoImage, SoIndexedFaceSet, SoIndexedNurbsCurve, SoIndexedNurbsSurface, SoIndexedPointSet, SoIndexedTriangleStripSet, SoLineSet, SoNurbsCurve, SoNurbsSurface, SoPointSet, SoQuadMesh, SoSphere, SoText2, SoText3, SoTriangleStripSet, SoVRMLBox, SoVRMLCone, SoVRMLCylinder, SoVRMLElevationGrid, SoVRMLExtrusion, SoVRMLIndexedFaceSet, SoVRMLIndexedLineSet, SoVRMLPointSet, SoVRMLSphere, and SoVRMLText.

## shouldGLRender()

SbBool SoShape::shouldGLRender | ( | SoGLRenderAction * | action | ) |

protected virtual

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

Reimplemented in SoVertexShape, SoVRMLGeometry, SoVRMLVertexLine, SoVRMLVertexPoint, and SoVRMLVertexShape.

## beginSolidShape()

void SoShape::beginSolidShape | ( | SoGLRenderAction * | action | ) |

protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## endSolidShape()

void SoShape::endSolidShape | ( | SoGLRenderAction * | action | ) |

protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## GLRenderBoundingBox()

void SoShape::GLRenderBoundingBox | ( | SoGLRenderAction * | action | ) |

protected

Render a bounding box.

## shouldPrimitiveCount()

SbBool SoShape::shouldPrimitiveCount | ( | SoGetPrimitiveCountAction * | action | ) |

protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## shouldRayPick()

SbBool SoShape::shouldRayPick | ( | SoRayPickAction *const | action | ) |

protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## computeObjectSpaceRay() [1/2]

void SoShape::computeObjectSpaceRay | ( | SoRayPickAction *const | action | ) |

protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## computeObjectSpaceRay() [2/2]

void SoShape::computeObjectSpaceRay | ( | SoRayPickAction *const | action,
|  | const SbMatrix & | matrix )

protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## createTriangleDetail()

SoDetail * SoShape::createTriangleDetail | ( | SoRayPickAction * | action,
|  | const SoPrimitiveVertex * | v1,
|  | const SoPrimitiveVertex * | v2,
|  | const SoPrimitiveVertex * | v3,
|  | SoPickedPoint * | pp )

protected virtual

Will create triangle detail for a SoPickedPoint. This method will only be called internally, when generatePrimitives() is used for picking (SoShape::rayPick() is not overridden).

This method returns `NULL` in Open Inventor, and subclasses will need to override this method to create details for a SoPickedPoint.

This is not necessary with Coin. Of course, if you choose to override it, it will work in the same way as Open Inventor.

For this to work, you must supply a face or line detail when generating primitives. If you supply `NULL` for the detail argument in SoShape::beginShape(), you'll have to override this method.

Reimplemented in SoAsciiText, SoIndexedNurbsSurface, SoNurbsSurface, SoText3, and SoVRMLExtrusion.

## createLineSegmentDetail()

SoDetail * SoShape::createLineSegmentDetail | ( | SoRayPickAction * | action,
|  | const SoPrimitiveVertex * | v1,
|  | const SoPrimitiveVertex * | v2,
|  | SoPickedPoint * | pp )

protected virtual

Will create line detail for a SoPickedPoint. This method will only be called internally, when generatePrimitives() is used for picking (SoShape::rayPick() is not overridden).

This method returns `NULL` in Open Inventor, and subclasses will need to override this method to create details for a SoPickedPoint.

This is not necessary with Coin. Of course, if you choose to override it, it will work in the same way as Open Inventor.

For this to work, you must supply a face or line detail when generating primitives. If you supply `NULL` for the detail argument in SoShape::beginShape(), you'll have to override this method.

Reimplemented in SoIndexedNurbsCurve, and SoNurbsCurve.

## createPointDetail()

SoDetail * SoShape::createPointDetail | ( | SoRayPickAction * | action,
|  | const SoPrimitiveVertex * | v,
|  | SoPickedPoint * | pp )

protected virtual

Will create point detail for a SoPickedPoint. This method will only be called internally, when generatePrimitives() is used for picking (SoShape::rayPick() is not overridden).

This method returns `NULL` in Open Inventor, and subclasses will need to override this method to create details for a SoPickedPoint.

This is not necessary with Coin. Of course, if you choose to override it, it will work in the same way as Open Inventor.

For this to work, you must supply a point detail in the SoPrimitiveVertex in generatePrimitives().

## invokeTriangleCallbacks()

void SoShape::invokeTriangleCallbacks | ( | SoAction *const | action,
|  | const SoPrimitiveVertex *const | v1,
|  | const SoPrimitiveVertex *const | v2,
|  | const SoPrimitiveVertex *const | v3 )

protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## invokeLineSegmentCallbacks()

void SoShape::invokeLineSegmentCallbacks | ( | SoAction *const | action,
|  | const SoPrimitiveVertex *const | v1,
|  | const SoPrimitiveVertex *const | v2 )

protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## invokePointCallbacks()

void SoShape::invokePointCallbacks | ( | SoAction *const | action,
|  | const SoPrimitiveVertex *const | v )

protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## beginShape()

void SoShape::beginShape | ( | SoAction *const | action,
|  | const TriangleShape | shapetype,
|  | SoDetail *const | detail = NULL )

protected

This method is used to generate primitives for a shape. It's typically called from a node's generatePrimitives() method. If you have your own shape and want to write a generatePrimitives() method for that shape, it's probably a good idea to take a peek in the generatePrimitives() method for a similar shape in Coin.

generatePrimitives() can contain several beginShape()/endShape() sequences. shapeVertex() is used for each vertex between beginShape() and endShape(). For instance, to generate primitives for a triangle you'd do something like this:

    SoPrimitiveVertex vertex;

    this->beginShape(action, SoShape::POLYGON);
    vertex.setPoint(SbVec3f(0.0f, 0.0f, 0.0f));
    this->shapeVertex(&vertex);
    vertex.setPoint(SbVec3f(1.0f, 0.0f, 0.0f));
    this->shapeVertex(&vertex);
    vertex.setPoint(SbVec3f(1.0f, 1.0f, 0.0f));
    this->shapeVertex(&vertex);
    this->endShape();

Note that the SoPrimitiveVertex instance can simply be placed on the stack and not allocated. SoShape will copy the needed information when you call shapeVertex().

Before calling shapeVertex(), you can set extra information for the SoPrimitiveVertex, including normal, material index, and texture coordinates.

This method is slightly different from its counterpart from the original Open Inventor library, as this method has an SoDetail as the last argument, and not an SoFaceDetail. This is because we accept more TriangleShape types, and the detail might be a SoFaceDetail or a SoLineDetail. There is no use sending in a SoPointDetail, as nothing will be done with it.

## shapeVertex()

void SoShape::shapeVertex | ( | const SoPrimitiveVertex *const | v | ) |

protected

This method is used while generating primitives for a shape. See beginShape() for more details.

See also
  beginShape(), endShape()

## endShape()

void SoShape::endShape | ( | void |  | ) |

protected

This method is used while generating primitives for a shape. See beginShape() for more details.

See also
  beginShape(), shapeVertex()

## generateVertex() [1/2]

void SoShape::generateVertex | ( | SoPrimitiveVertex *const | pv,
|  | const SbVec3f & | point,
|  | const SbBool | usetexfunc,
|  | const SoMultiTextureCoordinateElement *const | tce,
|  | const float | s,
|  | const float | t,
|  | const SbVec3f & | normal )

protected

Convenience function which sets up an SoPrimitiveVertex, and sends it using the SoShape::shapeVertex() function. 2D version

## generateVertex() [2/2]

void SoShape::generateVertex | ( | SoPrimitiveVertex *const | pv,
|  | const SbVec3f & | point,
|  | const SbBool | usetexfunc,
|  | const SoMultiTextureCoordinateElement *const | tce,
|  | const float | s,
|  | const float | t,
|  | const float | r,
|  | const SbVec3f & | normal )

protected

Convenience function which sets up an SoPrimitiveVertex, and sends it using the SoShape::shapeVertex() function. 3D version.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Since
  Coin 2.0

## startVertexArray()

SbBool SoShape::startVertexArray | ( | SoGLRenderAction * | action,
|  | const SoCoordinateElement * | coords,
|  | const SbVec3f * | pervertexnormals,
|  | const SbBool | texpervertex,
|  | const SbBool | colorpervertex )

protected

Convenience method that enables vertex arrays and/or VBOs Returns TRUE if VBO is used.

See also
  finishVertexArray()

Since
  Coin 3.0

## finishVertexArray()

void SoShape::finishVertexArray | ( | SoGLRenderAction * | action,
|  | const SbBool | vbo,
|  | const SbBool | normpervertex,
|  | const SbBool | texpervertex,
|  | const SbBool | colorpervertex )

protected

Should be called after rendering with vertex arrays. This method will disable arrays and VBOs enabled in the startVertexArray() function.

See also
  startVertexArray()

Since
  Coin 3.0

The documentation for this class was generated from the following files:

- SoShape.h
- SoShape.cpp